diff --git a/src/sbus/sbus_codegen b/src/sbus/sbus_codegen
index b4e63f33e6e5ef9fb56646142a29c97d35ca3ebf..fff5de75d167031f45ee87264770d9f04b4bf89f 100755
--- a/src/sbus/sbus_codegen
+++ b/src/sbus/sbus_codegen
@@ -190,7 +190,7 @@ class Property(Typed):
     def getter_name(self):
         return "%s_get_%s" % (self.iface.c_name(), self.c_name())
     def getter_invoker_name(self):
-        return "invoke_get_%s" % self.type
+        return "sbus_invoke_get_%s" % self.type
     def getter_signature(self, name):
         sig = "void (*%s)(struct sbus_request *, void *data, %s *" % (name, self.sssd_type)
         if self.is_array:
@@ -306,108 +306,6 @@ def source_prop_handler(prop, type_prefix=False):
     out("    %s", prop.getter_signature("%shandler" % prefix), new_line=False)
     out(";")
 
-def source_getter_invoker(prop):
-    out("")
-    if prop.is_array:
-        out("/* invokes a getter with an array of '%s' DBus type */", prop.dbus_type)
-    else:
-        out("/* invokes a getter with a '%s' DBus type */", prop.dbus_type)
-    out("static int %s(struct sbus_request *dbus_req, void *function_ptr)",
-        prop.getter_invoker_name())
-    out("{")
-
-    source_prop_types(prop)
-
-    out("")
-    out("    %s", prop.getter_signature("handler"), new_line=False)
-    out(" = function_ptr;")
-    out("")
-
-    out("    (handler)(dbus_req, dbus_req->intf->instance_data, &prop_val", new_line=False)
-    if prop.is_array:
-        out(", &prop_len", new_line=False)
-    out(");")
-
-    out("")
-    if prop.type == "s":
-        out("    out_val = prop_val == NULL ? \"\" : prop_val;")
-    elif prop.type == "o":
-        out("    out_val = prop_val == NULL ? \"/\" : prop_val;")
-    else:
-        out("    out_val = prop_val;")
-    if prop.is_array:
-        out("    return sbus_request_return_array_as_variant(dbus_req, %s, (uint8_t*)out_val, prop_len, sizeof(%s));", prop.dbus_constant, prop.sssd_type)
-    else:
-        out("    return sbus_request_return_as_variant(dbus_req, %s, &out_val);", prop.dbus_constant)
-    out("}")
-
-def source_getall_invoker(iface, prop_invokers):
-    out("")
-    out("/* invokes GetAll for the '%s' interface */", iface.name)
-    out("static int invoke_%s_get_all(struct sbus_request *dbus_req, void *function_ptr)",
-        iface.c_name())
-    out("{")
-    out("    DBusMessage *reply;")
-    out("    dbus_bool_t dbret;")
-    out("    DBusMessageIter iter;")
-    out("    DBusMessageIter iter_dict;")
-    if iface.properties:
-        out("    int ret;")
-        out("    struct sbus_interface *intf = dbus_req->intf;")
-        out("    const struct sbus_property_meta *property;")
-
-    iface_types = [ p.type for p in iface.properties ]
-    for prop in [ p for p in prop_invokers.values() if p.type in iface_types ]:
-        source_prop_types(prop, type_prefix=True)
-        source_prop_handler(prop, type_prefix=True)
-    out("")
-
-    out("    reply = dbus_message_new_method_return(dbus_req->message);")
-    out("    if (!reply) return ENOMEM;")
-    out("    dbus_message_iter_init_append(reply, &iter);")
-    out("    dbret = dbus_message_iter_open_container(")
-    out("                                     &iter, DBUS_TYPE_ARRAY,")
-    out("                                     DBUS_DICT_ENTRY_BEGIN_CHAR_AS_STRING")
-    out("                                     DBUS_TYPE_STRING_AS_STRING")
-    out("                                     DBUS_TYPE_VARIANT_AS_STRING")
-    out("                                     DBUS_DICT_ENTRY_END_CHAR_AS_STRING,")
-    out("                                     &iter_dict);")
-    out("    if (!dbret) return ENOMEM;")
-    out("")
-
-    for prop in iface.properties:
-        out("    property = sbus_meta_find_property(intf->vtable->meta, \"%s\");", prop.c_name())
-        out("    if (property != NULL && property->flags & SBUS_PROPERTY_READABLE) {")
-        out("        %s_handler = VTABLE_FUNC(intf->vtable, property->vtable_offset_get);", prop.type)
-        out("        if (%s_handler) {", prop.type)
-        out("            (%s_handler)(dbus_req, dbus_req->intf->instance_data, &%s_prop_val", prop.type, prop.type, new_line=False)
-        if prop.is_array:
-            out(", &%s_prop_len", prop.type, new_line=False)
-        out(");")
-        if prop.type == "s":
-            out("            %s_out_val = %s_prop_val == NULL ? \"\" : %s_prop_val;",
-                prop.type, prop.type, prop.type)
-        elif prop.type == "o":
-            out("            %s_out_val = %s_prop_val == NULL ? \"/\" : %s_prop_val;",
-                prop.type, prop.type, prop.type)
-        else:
-            out("            %s_out_val = %s_prop_val;", prop.type, prop.type)
-        if prop.is_array:
-            out("            ret = sbus_add_array_as_variant_to_dict(&iter_dict, \"%s\", %s, (uint8_t*)%s_out_val, %s_prop_len, sizeof(%s));", prop.c_name(), prop.dbus_constant, prop.type, prop.type, prop.sssd_type)
-        else:
-            out("            ret = sbus_add_variant_to_dict(&iter_dict, \"%s\", %s, &%s_out_val);", prop.c_name(), prop.dbus_constant, prop.type)
-        out("            if (ret != EOK) return ret;")
-        out("        }")
-        out("    }")
-        out("")
-
-    out("    dbret = dbus_message_iter_close_container(&iter, &iter_dict);")
-    out("    if (!dbret) return ENOMEM;")
-    out("")
-
-    out("    return sbus_request_finish(dbus_req, reply);")
-    out("}")
-
 def forward_method_invokers(ifaces):
     invokers = { }
     for iface in ifaces:
@@ -425,27 +323,6 @@ def source_method_invokers(invokers):
     for (signature, meth) in invokers.items():
         source_method_invoker(signature, meth.in_args)
 
-def forward_prop_invoker(prop):
-    out("static int %s(struct sbus_request *dbus_req, void *function_ptr);",
-        prop.getter_invoker_name())
-
-def forward_prop_invokers(ifaces):
-    invokers = { }
-    for iface in ifaces:
-        for prop in iface.properties:
-            if not prop.is_basic:
-                continue
-            if prop.type in invokers:
-                continue
-            forward_prop_invoker(prop)
-            invokers[prop.type] = prop
-    return invokers
-
-def source_prop_invokers(invokers):
-    for (type, prop) in invokers.items():
-        if prop.readable:
-            source_getter_invoker(prop)
-
 def source_finisher(meth):
     out("")
     out("int %s_finish(struct sbus_request *req%s)",
@@ -590,7 +467,7 @@ def source_interface(iface):
         out("    %s__properties,", iface.c_name())
     else:
         out("    NULL, /* no properties */")
-    out("    invoke_%s_get_all, /* GetAll invoker */", iface.c_name())
+    out("    sbus_invoke_get_all, /* GetAll invoker */")
     out("};")
 
 def generate_source(ifaces, filename, include_header=None):
@@ -602,11 +479,11 @@ def generate_source(ifaces, filename, include_header=None):
     out("#include \"util/util.h\"")
     out("#include \"sbus/sssd_dbus.h\"")
     out("#include \"sbus/sssd_dbus_meta.h\"")
+    out("#include \"sbus/sssd_dbus_invokers.h\"")
     if include_header:
         out("#include \"%s\"", os.path.basename(include_header))
 
     meth_invokers = forward_method_invokers(ifaces)
-    prop_invokers = forward_prop_invokers(ifaces)
 
     for iface in ifaces:
 
@@ -622,14 +499,10 @@ def generate_source(ifaces, filename, include_header=None):
         if iface.properties:
             source_properties(iface, iface.properties)
 
-        # always generate getall, for interfaces without properties
-        # let's return an empty array
-        source_getall_invoker(iface, prop_invokers)
         # The sbus_interface structure
         source_interface(iface)
 
     source_method_invokers(meth_invokers)
-    source_prop_invokers(prop_invokers)
 
 def header_finisher(iface, meth):
     if meth.use_raw_handler():
diff --git a/src/sbus/sssd_dbus_invokers.c b/src/sbus/sssd_dbus_invokers.c
new file mode 100644
index 0000000000000000000000000000000000000000..e37a2b76aca53b051834a1e37d4cbf5683f00d7a
--- /dev/null
+++ b/src/sbus/sssd_dbus_invokers.c
@@ -0,0 +1,424 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2014 Red Hat
+
+    SBUS: Interface introspection
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "config.h"
+
+#include <dbus/dbus.h>
+#include <errno.h>
+
+#include "util/util.h"
+#include "sbus/sssd_dbus.h"
+#include "sbus/sssd_dbus_meta.h"
+#include "sbus/sssd_dbus_private.h"
+#include "sbus/sssd_dbus_invokers.h"
+
+#define INVOKE_STRING(sbus_req, iter, fn, prop_type, default_val) do {       \
+    void (*handler_fn)(struct sbus_request *, void *, const char **);        \
+    const char *prop_val;                                                    \
+    const char *dbus_val;                                                    \
+    dbus_bool_t dbret;                                                       \
+                                                                             \
+    handler_fn = fn;                                                         \
+    handler_fn(sbus_req, sbus_req->intf->instance_data, &prop_val);          \
+                                                                             \
+    dbus_val = prop_val == NULL ? default_val : prop_val;                    \
+    dbret = dbus_message_iter_append_basic(iter, prop_type, &dbus_val);      \
+    return dbret ? EOK : EIO;                                                \
+} while (0)
+
+#define INVOKE_BASIC(sbus_req, iter, fn, prop_type, c_type, dbus_type) do {  \
+    void (*handler_fn)(struct sbus_request *, void *, c_type *);             \
+    c_type prop_val;                                                         \
+    dbus_type dbus_val;                                                      \
+    dbus_bool_t dbret;                                                       \
+                                                                             \
+    handler_fn = fn;                                                         \
+    handler_fn(sbus_req, sbus_req->intf->instance_data, &prop_val);          \
+                                                                             \
+    dbus_val = prop_val;                                                     \
+    dbret = dbus_message_iter_append_basic(iter, prop_type, &dbus_val);      \
+    return dbret ? EOK : EIO;                                                \
+} while (0)
+
+#define INVOKE_ARRAY(sbus_req, iter, fn, prop_type, c_type, dbus_type) do {  \
+    void (*handler_fn)(struct sbus_request *, void *, c_type *, int *);      \
+    DBusMessageIter array;                                                   \
+    const char array_type[2] = {prop_type, '\0'};                            \
+    c_type prop_val;                                                         \
+    dbus_type dbus_val;                                                      \
+    dbus_bool_t dbret;                                                       \
+    int prop_len;                                                            \
+    int i;                                                                   \
+                                                                             \
+    handler_fn = fn;                                                         \
+    handler_fn(sbus_req, sbus_req->intf->instance_data,                      \
+               &prop_val, &prop_len);                                        \
+                                                                             \
+    dbus_val = prop_val;                                                     \
+    dbret = dbus_message_iter_open_container(iter, DBUS_TYPE_ARRAY,          \
+                                             array_type, &array);            \
+    if (!dbret) {                                                            \
+        return EIO;                                                          \
+    }                                                                        \
+                                                                             \
+    for (i = 0; i < prop_len; i++) {                                         \
+        dbret = dbus_message_iter_append_basic(&array, prop_type,            \
+                                               &dbus_val[i]);                \
+        if (!dbret) {                                                        \
+            return EIO;                                                      \
+        }                                                                    \
+    }                                                                        \
+                                                                             \
+    dbret = dbus_message_iter_close_container(iter, &array);                 \
+    if (!dbret) {                                                            \
+        return EIO;                                                          \
+    }                                                                        \
+                                                                             \
+    return dbret ? EOK : EIO;                                                \
+} while (0)
+
+int sbus_invoke_get_y(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_BYTE,
+                 uint8_t, uint8_t);
+}
+
+int sbus_invoke_get_b(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_BOOLEAN,
+                 bool, dbus_bool_t);
+}
+
+int sbus_invoke_get_n(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_INT16,
+                 int16_t, int16_t);
+}
+
+int sbus_invoke_get_q(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_UINT16,
+                 uint16_t, uint16_t);
+}
+
+int sbus_invoke_get_i(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_INT32,
+                 int32_t, int32_t);
+}
+
+int sbus_invoke_get_u(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_UINT32,
+                 uint32_t, uint32_t);
+}
+
+int sbus_invoke_get_x(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_INT64,
+                 int64_t, int64_t);
+}
+
+int sbus_invoke_get_t(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_UINT64,
+                 uint64_t, uint64_t);
+}
+
+int sbus_invoke_get_d(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_BASIC(sbus_req, iter, function_ptr, DBUS_TYPE_DOUBLE,
+                 double, double);
+}
+
+int sbus_invoke_get_s(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_STRING(sbus_req, iter, function_ptr, DBUS_TYPE_STRING, "");
+}
+
+int sbus_invoke_get_o(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr)
+{
+    INVOKE_STRING(sbus_req, iter, function_ptr, DBUS_TYPE_OBJECT_PATH, "/");
+}
+
+int sbus_invoke_get_ay(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_BYTE,
+                 uint8_t *, uint8_t *);
+}
+
+int sbus_invoke_get_an(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_INT16,
+                 int16_t *, int16_t *);
+}
+
+int sbus_invoke_get_aq(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_UINT16,
+                 uint16_t *, uint16_t *);
+}
+
+int sbus_invoke_get_ai(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_INT32,
+                 int32_t *, int32_t *);
+}
+
+int sbus_invoke_get_au(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_UINT32,
+                 uint32_t *, uint32_t *);
+}
+
+int sbus_invoke_get_ax(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_INT64,
+                 int64_t *, int64_t *);
+}
+
+int sbus_invoke_get_at(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_UINT64,
+                 uint64_t *, uint64_t *);
+}
+
+int sbus_invoke_get_ad(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_DOUBLE,
+                 double *, double *);
+}
+
+int sbus_invoke_get_as(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_STRING,
+                 const char **, const char **);
+}
+
+int sbus_invoke_get_ao(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr)
+{
+    INVOKE_ARRAY(sbus_req, iter, function_ptr, DBUS_TYPE_OBJECT_PATH,
+                 const char **, const char **);
+}
+
+void sbus_invoke_get(struct sbus_request *sbus_req,
+                     const char *type,
+                     sbus_get_invoker_fn invoker_fn,
+                     sbus_msg_handler_fn handler_fn)
+{
+    DBusMessage *reply = NULL;
+    DBusMessageIter iter;
+    DBusMessageIter variant;
+    dbus_bool_t dbret;
+    errno_t ret;
+
+    reply = dbus_message_new_method_return(sbus_req->message);
+    if (reply == NULL) {
+        ret = ENOMEM;
+        goto fail;
+    }
+
+    dbus_message_iter_init_append(reply, &iter);
+
+    dbret = dbus_message_iter_open_container(&iter, DBUS_TYPE_VARIANT,
+                                             type, &variant);
+    if (!dbret) {
+        ret = ENOMEM;
+        goto fail;
+    }
+
+    ret = invoker_fn(&variant, sbus_req, handler_fn);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE,
+              "Invoker error [%d]: %s\n", ret, sss_strerror(ret));
+        goto fail;
+    }
+
+    dbret = dbus_message_iter_close_container(&iter, &variant);
+    if (!dbret) {
+        ret = EIO;
+        goto fail;
+    }
+
+    sbus_request_finish(sbus_req, reply);
+    return;
+
+fail:
+    DEBUG(SSSDBG_CRIT_FAILURE,
+          "Unable to reply [%d]: %s\n", ret, sss_strerror(ret));
+
+    if (reply != NULL) {
+        dbus_message_unref(reply);
+    }
+    sbus_request_finish(sbus_req, NULL);
+
+    return;
+}
+
+void sbus_invoke_get_all(struct sbus_request *sbus_req)
+{
+    const struct sbus_property_meta *props;
+    sbus_msg_handler_fn *handler_fn;
+    DBusMessage *reply = NULL;
+    DBusMessageIter iter;
+    DBusMessageIter array;
+    DBusMessageIter dict;
+    DBusMessageIter variant;
+    dbus_bool_t dbret;
+    errno_t ret;
+    int i;
+
+    reply = dbus_message_new_method_return(sbus_req->message);
+    if (reply == NULL) {
+        ret = ENOMEM;
+        goto fail;
+    }
+
+    dbus_message_iter_init_append(reply, &iter);
+
+    dbret = dbus_message_iter_open_container(&iter, DBUS_TYPE_ARRAY,
+                                     DBUS_DICT_ENTRY_BEGIN_CHAR_AS_STRING
+                                     DBUS_TYPE_STRING_AS_STRING
+                                     DBUS_TYPE_VARIANT_AS_STRING
+                                     DBUS_DICT_ENTRY_END_CHAR_AS_STRING,
+                                     &array);
+    if (!dbret) {
+        ret = ENOMEM;
+        goto fail;
+    }
+
+    props = sbus_req->intf->vtable->meta->properties;
+
+    if (props != NULL) {
+        for (i = 0; props[i].name != NULL; i++) {
+            dbret = dbus_message_iter_open_container(&array,
+                                                     DBUS_TYPE_DICT_ENTRY, NULL,
+                                                     &dict);
+            if (!dbret) {
+                ret = ENOMEM;
+                goto fail;
+            }
+
+            /* key */
+            dbret = dbus_message_iter_append_basic(&dict, DBUS_TYPE_STRING,
+                                                   &props[i].name);
+            if (!dbret) {
+                ret = ENOMEM;
+                goto fail;
+            }
+
+            /* value */
+            dbret = dbus_message_iter_open_container(&dict, DBUS_TYPE_VARIANT,
+                                                     props[i].type, &variant);
+            if (!dbret) {
+                ret = ENOMEM;
+                goto fail;
+            }
+
+            handler_fn = VTABLE_FUNC(sbus_req->intf->vtable,
+                                     props[i].vtable_offset_get);
+            if (handler_fn == NULL) {
+                ret = ERR_INTERNAL;
+                goto fail;
+            }
+
+            ret = props[i].invoker_get(&variant, sbus_req, handler_fn);
+            if (ret != EOK) {
+                DEBUG(SSSDBG_CRIT_FAILURE,
+                      "Invoker error [%d]: %s\n", ret, sss_strerror(ret));
+                goto fail;
+            }
+
+            dbret = dbus_message_iter_close_container(&dict, &variant);
+            if (!dbret) {
+                ret = EIO;
+                goto fail;
+            }
+
+            dbret = dbus_message_iter_close_container(&array, &dict);
+            if (!dbret) {
+                ret = EIO;
+                goto fail;
+            }
+        }
+    }
+
+    dbret = dbus_message_iter_close_container(&iter, &array);
+    if (!dbret) {
+        ret = EIO;
+        goto fail;
+    }
+
+    sbus_request_finish(sbus_req, reply);
+    return;
+
+fail:
+    DEBUG(SSSDBG_CRIT_FAILURE,
+          "Unable to reply [%d]: %s\n", ret, sss_strerror(ret));
+
+    dbus_message_unref(reply);
+    sbus_request_finish(sbus_req, NULL);
+
+    return;
+}
diff --git a/src/sbus/sssd_dbus_invokers.h b/src/sbus/sssd_dbus_invokers.h
new file mode 100644
index 0000000000000000000000000000000000000000..8fd49859489e79734e33d85bc03d19f8f1cb77ad
--- /dev/null
+++ b/src/sbus/sssd_dbus_invokers.h
@@ -0,0 +1,120 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2014 Red Hat
+
+    SBUS: Interface introspection
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef SSSD_DBUS_INVOKER_H_
+#define SSSD_DBUS_INVOKER_H_
+
+#include "sbus/sssd_dbus.h"
+
+int sbus_invoke_get_y(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_b(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_n(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_q(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_i(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_u(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_x(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_t(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_d(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_s(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_o(DBusMessageIter *iter,
+                      struct sbus_request *sbus_req,
+                      void *function_ptr);
+
+int sbus_invoke_get_ay(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_an(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_aq(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_ai(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_au(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_ax(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_at(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_ad(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_as(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+int sbus_invoke_get_ao(DBusMessageIter *iter,
+                       struct sbus_request *sbus_req,
+                       void *function_ptr);
+
+void sbus_invoke_get(struct sbus_request *sbus_req,
+                     const char *type,
+                     sbus_get_invoker_fn invoker_fn,
+                     sbus_msg_handler_fn handler_fn);
+
+void sbus_invoke_get_all(struct sbus_request *sbus_req);
+
+
+#endif /* SSSD_DBUS_INVOKER_H_ */
diff --git a/src/sbus/sssd_dbus_meta.h b/src/sbus/sssd_dbus_meta.h
index e7de9dfdfb4d46e88d3f59f366ca7190a09afc57..83c2f0517790c2be7eb3253a24cf0f040de1d568 100644
--- a/src/sbus/sssd_dbus_meta.h
+++ b/src/sbus/sssd_dbus_meta.h
@@ -21,6 +21,8 @@
 #ifndef _SSSD_DBUS_META_H_
 #define _SSSD_DBUS_META_H_
 
+#include <dbus/dbus.h>
+
 /*
  * Interface metadata
  *
@@ -45,7 +47,14 @@ struct sbus_arg_meta {
 struct sbus_request;
 struct sbus_interface;
 
-typedef int (* sbus_method_invoker_fn)(struct sbus_request *dbus_req, void *handler_fn);
+typedef int (* sbus_get_invoker_fn)(DBusMessageIter *iter,
+                                    struct sbus_request *sbus_req,
+                                    void *handler_fn);
+
+typedef void (* sbus_get_all_invoker_fn)(struct sbus_request *sbus_req);
+
+typedef int (* sbus_method_invoker_fn)(struct sbus_request *sbus_req,
+                                       void *handler_fn);
 
 struct sbus_method_meta {
     const char *name;
@@ -65,7 +74,7 @@ struct sbus_property_meta {
     const char *type;
     int flags;
     size_t vtable_offset_get;
-    sbus_method_invoker_fn invoker_get;
+    sbus_get_invoker_fn invoker_get;
     size_t vtable_offset_set;
     sbus_method_invoker_fn invoker_set;
 };
@@ -80,7 +89,7 @@ struct sbus_interface_meta {
     const struct sbus_method_meta *methods;
     const struct sbus_signal_meta *signals;
     const struct sbus_property_meta *properties;
-    sbus_method_invoker_fn invoker_get_all;
+    sbus_get_all_invoker_fn invoker_get_all;
 };
 
 const struct sbus_method_meta *
